<?php


namespace Modules\User\Controller;

use Venom\Core\ArgumentHandler;
use Venom\Core\Database\EasyQuery;
use Venom\Core\Database\EntityManager;
use Venom\Entities\User;
use Venom\Helper\AdminHelper;

class UserAPIController
{
    public function get()
    {
        $entityManager = EntityManager::create(User::class);
        $easyQuery = new EasyQuery(User::$tableName, ["id", "username", "firstname", "lastname", "email", "isActive"]);
        $entityManager->load($easyQuery);
        //['id' => 1, 'name' => 'engineertrooper', 'icon' => 'vt-edit'],
        AdminHelper::sendResponse(["users" => $entityManager->getAll()]);
    }

    public function getById($id)
    {
        $entityManager = EntityManager::create(User::class);
        $easyQuery = new EasyQuery(User::$tableName, ["id", "username", "firstname", "lastname", "email", "isActive"]);
        $easyQuery->where("id", $id);
        $entityManager->load($easyQuery);
        AdminHelper::sendResponse($entityManager->getFirst());
    }

    public function update($id)
    {
        $entityManager = EntityManager::create(User::class);
        $easyQuery = new EasyQuery(User::$tableName, ["id", "username", "firstname", "lastname", "email", "isActive"]);
        $easyQuery->where("id", $id);
        $entityManager->load($easyQuery);
        /** @var User|null $original */
        $original = $entityManager->getFirst();
        if ($original == null) {
            AdminHelper::sendStatus(false, "User not Found");
        }
        parse_str(file_get_contents('php://input'), $_PUT);
/*        var_dump(array_keys($_PUT));*/
        AdminHelper::sendStatus($entityManager->saveAll());
    }

    public function delete($id)
    {
    }

    public function create($id)
    {
        // INSERT INTO
        AdminHelper::sendStatus(true);
    }
}